// This file was generated by gir (https://github.com/gtk-rs/gir)
// from gir-files (https://github.com/gtk-rs/gir-files)
// from gst-gir-files (https://gitlab.freedesktop.org/gstreamer/gir-files-rs.git)
// DO NOT EDIT

use crate::InterpolationMode;
use crate::TimedValueControlSource;
use glib::object::Cast;
use glib::object::IsA;
use glib::signal::connect_raw;
use glib::signal::SignalHandlerId;
use glib::translate::*;
use glib::StaticType;
use std::boxed::Box as Box_;
use std::mem::transmute;

glib::wrapper! {
    pub struct InterpolationControlSource(Object<ffi::GstInterpolationControlSource, ffi::GstInterpolationControlSourceClass>) @extends TimedValueControlSource, gst::ControlSource, gst::Object;

    match fn {
        get_type => || ffi::gst_interpolation_control_source_get_type(),
    }
}

impl InterpolationControlSource {
    #[doc(alias = "gst_interpolation_control_source_new")]
    pub fn new() -> InterpolationControlSource {
        assert_initialized_main_thread!();
        unsafe {
            gst::ControlSource::from_glib_full(ffi::gst_interpolation_control_source_new())
                .unsafe_cast()
        }
    }
}

impl Default for InterpolationControlSource {
    fn default() -> Self {
        Self::new()
    }
}

unsafe impl Send for InterpolationControlSource {}
unsafe impl Sync for InterpolationControlSource {}

pub const NONE_INTERPOLATION_CONTROL_SOURCE: Option<&InterpolationControlSource> = None;

pub trait InterpolationControlSourceExt: 'static {
    fn get_property_mode(&self) -> InterpolationMode;

    fn set_property_mode(&self, mode: InterpolationMode);

    fn connect_property_mode_notify<F: Fn(&Self) + Send + Sync + 'static>(
        &self,
        f: F,
    ) -> SignalHandlerId;
}

impl<O: IsA<InterpolationControlSource>> InterpolationControlSourceExt for O {
    fn get_property_mode(&self) -> InterpolationMode {
        unsafe {
            let mut value =
                glib::Value::from_type(<InterpolationMode as StaticType>::static_type());
            glib::gobject_ffi::g_object_get_property(
                self.to_glib_none().0 as *mut glib::gobject_ffi::GObject,
                b"mode\0".as_ptr() as *const _,
                value.to_glib_none_mut().0,
            );
            value
                .get()
                .expect("Return Value for property `mode` getter")
                .unwrap()
        }
    }

    fn set_property_mode(&self, mode: InterpolationMode) {
        unsafe {
            glib::gobject_ffi::g_object_set_property(
                self.to_glib_none().0 as *mut glib::gobject_ffi::GObject,
                b"mode\0".as_ptr() as *const _,
                glib::Value::from(&mode).to_glib_none().0,
            );
        }
    }

    fn connect_property_mode_notify<F: Fn(&Self) + Send + Sync + 'static>(
        &self,
        f: F,
    ) -> SignalHandlerId {
        unsafe extern "C" fn notify_mode_trampoline<P, F: Fn(&P) + Send + Sync + 'static>(
            this: *mut ffi::GstInterpolationControlSource,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) where
            P: IsA<InterpolationControlSource>,
        {
            let f: &F = &*(f as *const F);
            f(&InterpolationControlSource::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::mode\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_mode_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }
}
